#!/usr/bin/perl
use Date::Manip;
require "cgi-lib2.pl";

$data =  "/space/www/htdocs/urlbot/urls.dat";

ReadParse();
foreach $key (keys %in) {
    $in{$key} =~ s/^\s+$//;
}
$start = $in{start} ? $in{start} : "midnight yesterday";
$end = $in{end} ? $in{end} : "now";
$search = $in{search} ? $in{search} : "#foo";

$ts1 = UnixDate($start,"%s");
if (!$ts1) {
    $start = "midnight yesterday";
    $ts1 = UnixDate($start,"%s");
}
$ts2 = UnixDate($end,"%s");
if (!$ts2) {
    $end = "now";
    $ts2 = UnixDate($end,"%s");
}

if ($ts2 < $ts1) {
    my $tmp = $ts1;
    $ts1 = $ts2;
    $ts2 = $tmp;
}

print qq{Content-type: text/html

<html>
<head>
<title>urlbot</title>
</head>
<body>
Urlbot commands:
<ul>
<li> seen *
<li> join * / leave *
<li> switch
<li> status
<li> help
<li> quit
</ul>

<form action="" method="POST">
Search for <input type="text" name="search" value="$search">
between <input type="text" name="start" value="$start">
and <input type="text" name="end" value="$end">.
Numbers must not be spelled out ("two days ago" will fail; "2 days ago" will
work)  but otherwise most sane date formats are parsed. For example, from "last tuesday" to "last wednesday 11:59pm" wll show everything from the beginning of last tuesday to the end of last wednesday.
<input type="submit" name="submit" value="Submit Query">
</form>
};


filter();
display();
exit;


sub filter {
    open(IN, $data);
    $i = 0;
    while(<IN>) {
	chomp;
	($ts,$who,$where,$url,$context) = split /$;/;
	if ($search) {
	    if (! m/$search/i) {
		next;
	    }
	}
	if ($ts > $ts2) {
	    last;
	}
	if ($ts < $ts1) {
	    next;
	}
	$data[$i]->[0] = $who;
	$data[$i]->[1] = $where;
	$data[$i]->[2] = $url;
	$data[$i]->[3] = $context;
	$data[$i]->[4] = $ts;
	$i++;
    }
    close IN;
}

sub display {
    @sorted = sort { $b->[4] <=> $a->[4] } @data;
    for ($i = 0; $i <= $#sorted; $i++)  {
	$time = localtime($sorted[$i]->[4]);
	print qq{
<p>
<a href="$sorted[$i]->[2]">$sorted[$i]->[2]</a><br>
&lt;$sorted[$i]->[0]:$sorted[$i]->[1]&gt; $sorted[$i]->[3] ($time)
</p>
};
    }
}
	    

